## Contributing code

Any code that you contribute will be licensed under the GPLv3-license adopted by salmon. However, by contributing
code to this project, you also extend permission for your contribution to be re-licensed under the BSD 3-clause 
license (under which we anticipate Salmon will be released once existing GPL code can be removed).

Code contributions should be made via pull requests.  Please make all PRs to the _develop_ branch 
of the repository.  PRs made to the _master_ branch may be rejected if they cannot be cleanly rebased 
on _develop_.  Before you make a PR, please check that:

 * Your PR describes the purpose of your commit. Is it fixing a bug, adding functionality, etc.?
 * Commit messages have been made using [*conventional commits*](https://www.conventionalcommits.org/en/v1.0.0/) — please format all of your commit messages as such.
 * Any non-obvious code is documented (we don't yet have formal documentation guidelines yet, so use common sense)
